<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.extend.dao.ibatis.ExtendHisprocinstDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="ExtendHisprocinstEntity" id="ExtendHisprocinstEntity-Map">
        <result property="id" column="id" />
        <result property="processInstanceId" column="processInstanceId" />
        <result property="processDefinitionId" column="processDefinitionId" />
        <result property="modelKey" column="modelKey" />
        <result property="businessKey" column="businessKey" />
        <result property="processStatus" column="processStatus" />
        <result property="processName" column="processName" />
        <result property="currentUserCode" column="currentUserCode" />
        <result property="tenantId" column="tenantId" />
        <result property="createUser" column="createUser" />
        <result property="createTime" column="createTime" />
        <result property="updateUser" column="updateUser" />
        <result property="updateTime" column="updateTime" />
    </resultMap>

    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id as id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('processInstanceId') or colPickMode == 1 and data.containsKey('processInstanceId')))">
                    a.processInstanceId as processInstanceId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('processDefinitionId') or colPickMode == 1 and data.containsKey('processDefinitionId')))">
                    a.processDefinitionId as processDefinitionId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('modelKey') or colPickMode == 1 and data.containsKey('modelKey')))">
                    a.modelKey as modelKey,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('businessKey') or colPickMode == 1 and data.containsKey('businessKey')))">
                    a.businessKey as businessKey,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('processStatus') or colPickMode == 1 and data.containsKey('processStatus')))">
                    a.processStatus as processStatus,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('processName') or colPickMode == 1 and data.containsKey('processName')))">
                    a.processName as processName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('currentUserCode') or colPickMode == 1 and data.containsKey('currentUserCode')))">
                    a.currentUserCode as currentUserCode,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('tenantId') or colPickMode == 1 and data.containsKey('tenantId')))">
                    a.tenantId as tenantId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createUser') or colPickMode == 1 and data.containsKey('createUser')))">
                    a.createUser as createUser,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime as createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUser') or colPickMode == 1 and data.containsKey('updateUser')))">
                    a.updateUser as updateUser,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime as updateTime,
                </if>
        </trim>
    </sql>
    <!-- 新增 -->
        <insert id="insert" parameterType="ExtendHisprocinstEntity" useGeneratedKeys="true" keyProperty="id">
            insert into mortals_flow_extend_hisprocinst
            (processInstanceId,processDefinitionId,modelKey,businessKey,processStatus,processName,currentUserCode,tenantId,createUser,createTime,updateUser,updateTime)
            VALUES
            (#{processInstanceId},#{processDefinitionId},#{modelKey},#{businessKey},#{processStatus},#{processName},#{currentUserCode},#{tenantId},#{createUser},#{createTime},#{updateUser},#{updateTime})
        </insert>

        <!-- 批量新增 -->
        <insert id="insertBatch" parameterType="paramDto">
            insert into mortals_flow_extend_hisprocinst
            (processInstanceId,processDefinitionId,modelKey,businessKey,processStatus,processName,currentUserCode,tenantId,createUser,createTime,updateUser,updateTime)
            VALUES
            <foreach collection="data.dataList" item="item" index="index" separator="," >
                (#{item.processInstanceId},#{item.processDefinitionId},#{item.modelKey},#{item.businessKey},#{item.processStatus},#{item.processName},#{item.currentUserCode},#{item.tenantId},#{item.createUser},#{item.createTime},#{item.updateUser},#{item.updateTime})
            </foreach>
        </insert>
    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_flow_extend_hisprocinst as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('processInstanceId')) or (colPickMode==1 and !data.containsKey('processInstanceId'))">
                a.processInstanceId=#{data.processInstanceId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('processDefinitionId')) or (colPickMode==1 and !data.containsKey('processDefinitionId'))">
                a.processDefinitionId=#{data.processDefinitionId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('modelKey')) or (colPickMode==1 and !data.containsKey('modelKey'))">
                a.modelKey=#{data.modelKey},
            </if>
            <if test="(colPickMode==0 and data.containsKey('businessKey')) or (colPickMode==1 and !data.containsKey('businessKey'))">
                a.businessKey=#{data.businessKey},
            </if>
            <if test="(colPickMode==0 and data.containsKey('processStatus')) or (colPickMode==1 and !data.containsKey('processStatus'))">
                a.processStatus=#{data.processStatus},
            </if>
            <if test="(colPickMode==0 and data.containsKey('processName')) or (colPickMode==1 and !data.containsKey('processName'))">
                a.processName=#{data.processName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('currentUserCode')) or (colPickMode==1 and !data.containsKey('currentUserCode'))">
                a.currentUserCode=#{data.currentUserCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('tenantId')) or (colPickMode==1 and !data.containsKey('tenantId'))">
                a.tenantId=#{data.tenantId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createUser')) or (colPickMode==1 and !data.containsKey('createUser'))">
                a.createUser=#{data.createUser},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUser')) or (colPickMode==1 and !data.containsKey('updateUser'))">
                a.updateUser=#{data.updateUser},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_flow_extend_hisprocinst as a
        <trim prefix="set" suffixOverrides=",">


                <trim prefix="processInstanceId=(case" suffix="ELSE processInstanceId end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('processInstanceId')) or (colPickMode==1 and !item.containsKey('processInstanceId'))">
                            when a.id=#{item.id} then #{item.processInstanceId}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="processDefinitionId=(case" suffix="ELSE processDefinitionId end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('processDefinitionId')) or (colPickMode==1 and !item.containsKey('processDefinitionId'))">
                            when a.id=#{item.id} then #{item.processDefinitionId}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="modelKey=(case" suffix="ELSE modelKey end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('modelKey')) or (colPickMode==1 and !item.containsKey('modelKey'))">
                            when a.id=#{item.id} then #{item.modelKey}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="businessKey=(case" suffix="ELSE businessKey end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('businessKey')) or (colPickMode==1 and !item.containsKey('businessKey'))">
                            when a.id=#{item.id} then #{item.businessKey}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="processStatus=(case" suffix="ELSE processStatus end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('processStatus')) or (colPickMode==1 and !item.containsKey('processStatus'))">
                            when a.id=#{item.id} then #{item.processStatus}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="processName=(case" suffix="ELSE processName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('processName')) or (colPickMode==1 and !item.containsKey('processName'))">
                            when a.id=#{item.id} then #{item.processName}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="currentUserCode=(case" suffix="ELSE currentUserCode end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('currentUserCode')) or (colPickMode==1 and !item.containsKey('currentUserCode'))">
                            when a.id=#{item.id} then #{item.currentUserCode}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="tenantId=(case" suffix="ELSE tenantId end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('tenantId')) or (colPickMode==1 and !item.containsKey('tenantId'))">
                            when a.id=#{item.id} then #{item.tenantId}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="createUser=(case" suffix="ELSE createUser end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createUser')) or (colPickMode==1 and !item.containsKey('createUser'))">
                            when a.id=#{item.id} then #{item.createUser}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="updateUser=(case" suffix="ELSE updateUser end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateUser')) or (colPickMode==1 and !item.containsKey('updateUser'))">
                            when a.id=#{item.id} then #{item.updateUser}
                        </if>
                    </foreach>
                </trim>

                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="ExtendHisprocinstEntity-Map">
        select <include refid="_columns"/>
        from mortals_flow_extend_hisprocinst as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_flow_extend_hisprocinst as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_flow_extend_hisprocinst where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_flow_extend_hisprocinst as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="ExtendHisprocinstEntity-Map">
        select <include refid="_columns"/>
        from mortals_flow_extend_hisprocinst as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>
    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_flow_extend_hisprocinst as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>

        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList')">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>


            <if test="conditionParamRef.containsKey('processInstanceId')">
                <if test="conditionParamRef.processInstanceId != null and conditionParamRef.processInstanceId != ''">
                    ${_conditionType_} a.processInstanceId like #{${_conditionParam_}.processInstanceId}
                </if>
                <if test="conditionParamRef.processInstanceId == null">
                    ${_conditionType_} a.processInstanceId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('processInstanceIdList')">
                ${_conditionType_} a.processInstanceId in
                <foreach collection="conditionParamRef.processInstanceIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('processDefinitionId')">
                <if test="conditionParamRef.processDefinitionId != null and conditionParamRef.processDefinitionId != ''">
                    ${_conditionType_} a.processDefinitionId like #{${_conditionParam_}.processDefinitionId}
                </if>
                <if test="conditionParamRef.processDefinitionId == null">
                    ${_conditionType_} a.processDefinitionId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('processDefinitionIdList')">
                ${_conditionType_} a.processDefinitionId in
                <foreach collection="conditionParamRef.processDefinitionIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('modelKey')">
                <if test="conditionParamRef.modelKey != null and conditionParamRef.modelKey != ''">
                    ${_conditionType_} a.modelKey like #{${_conditionParam_}.modelKey}
                </if>
                <if test="conditionParamRef.modelKey == null">
                    ${_conditionType_} a.modelKey is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('modelKeyList')">
                ${_conditionType_} a.modelKey in
                <foreach collection="conditionParamRef.modelKeyList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('businessKey')">
                <if test="conditionParamRef.businessKey != null and conditionParamRef.businessKey != ''">
                    ${_conditionType_} a.businessKey like #{${_conditionParam_}.businessKey}
                </if>
                <if test="conditionParamRef.businessKey == null">
                    ${_conditionType_} a.businessKey is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('businessKeyList')">
                ${_conditionType_} a.businessKey in
                <foreach collection="conditionParamRef.businessKeyList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('processStatus')">
                <if test="conditionParamRef.processStatus != null and conditionParamRef.processStatus != ''">
                    ${_conditionType_} a.processStatus like #{${_conditionParam_}.processStatus}
                </if>
                <if test="conditionParamRef.processStatus == null">
                    ${_conditionType_} a.processStatus is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('processStatusList')">
                ${_conditionType_} a.processStatus in
                <foreach collection="conditionParamRef.processStatusList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('processName')">
                <if test="conditionParamRef.processName != null and conditionParamRef.processName != ''">
                    ${_conditionType_} a.processName like #{${_conditionParam_}.processName}
                </if>
                <if test="conditionParamRef.processName == null">
                    ${_conditionType_} a.processName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('processNameList')">
                ${_conditionType_} a.processName in
                <foreach collection="conditionParamRef.processNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('currentUserCode')">
                <if test="conditionParamRef.currentUserCode != null and conditionParamRef.currentUserCode != ''">
                    ${_conditionType_} a.currentUserCode like #{${_conditionParam_}.currentUserCode}
                </if>
                <if test="conditionParamRef.currentUserCode == null">
                    ${_conditionType_} a.currentUserCode is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('currentUserCodeList')">
                ${_conditionType_} a.currentUserCode in
                <foreach collection="conditionParamRef.currentUserCodeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('tenantId')">
                <if test="conditionParamRef.tenantId != null and conditionParamRef.tenantId != ''">
                    ${_conditionType_} a.tenantId like #{${_conditionParam_}.tenantId}
                </if>
                <if test="conditionParamRef.tenantId == null">
                    ${_conditionType_} a.tenantId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('tenantIdList')">
                ${_conditionType_} a.tenantId in
                <foreach collection="conditionParamRef.tenantIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('createUser')">
                <if test="conditionParamRef.createUser != null and conditionParamRef.createUser != ''">
                    ${_conditionType_} a.createUser like #{${_conditionParam_}.createUser}
                </if>
                <if test="conditionParamRef.createUser == null">
                    ${_conditionType_} a.createUser is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createUserList')">
                ${_conditionType_} a.createUser in
                <foreach collection="conditionParamRef.createUserList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>

            <if test="conditionParamRef.containsKey('updateUser')">
                <if test="conditionParamRef.updateUser != null and conditionParamRef.updateUser != ''">
                    ${_conditionType_} a.updateUser like #{${_conditionParam_}.updateUser}
                </if>
                <if test="conditionParamRef.updateUser == null">
                    ${_conditionType_} a.updateUser is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateUserList')">
                ${_conditionType_} a.updateUser in
                <foreach collection="conditionParamRef.updateUserList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('processInstanceId')">
                        a.processInstanceId
                        <if test='orderCol.processInstanceId != null and "DESC".equalsIgnoreCase(orderCol.processInstanceId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('processDefinitionId')">
                        a.processDefinitionId
                        <if test='orderCol.processDefinitionId != null and "DESC".equalsIgnoreCase(orderCol.processDefinitionId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('modelKey')">
                        a.modelKey
                        <if test='orderCol.modelKey != null and "DESC".equalsIgnoreCase(orderCol.modelKey)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('businessKey')">
                        a.businessKey
                        <if test='orderCol.businessKey != null and "DESC".equalsIgnoreCase(orderCol.businessKey)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('processStatus')">
                        a.processStatus
                        <if test='orderCol.processStatus != null and "DESC".equalsIgnoreCase(orderCol.processStatus)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('processName')">
                        a.processName
                        <if test='orderCol.processName != null and "DESC".equalsIgnoreCase(orderCol.processName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('currentUserCode')">
                        a.currentUserCode
                        <if test='orderCol.currentUserCode != null and "DESC".equalsIgnoreCase(orderCol.currentUserCode)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('tenantId')">
                        a.tenantId
                        <if test='orderCol.tenantId != null and "DESC".equalsIgnoreCase(orderCol.tenantId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createUser')">
                        a.createUser
                        <if test='orderCol.createUser != null and "DESC".equalsIgnoreCase(orderCol.createUser)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateUser')">
                        a.updateUser
                        <if test='orderCol.updateUser != null and "DESC".equalsIgnoreCase(orderCol.updateUser)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>